let text = "Hello World"

let read_done result =
  let buffer = Aio.result result
  in
    Printf.printf "Got '%s'\n" (Aio.get_string buffer (String.length text));
    flush_all ()

let write_done ctx fd result =
  let buffer = Aio.result result
  in
    Printf.printf "write done\n";
    flush_all ();
    Aio.read ctx fd buffer Int64.zero read_done

let _ = at_exit Gc.full_major

let _ =
  let fd = Unix.openfile "testfile" [Unix.O_RDWR; Unix.O_CREAT] 0o664 in
  let buffer = Aio.buffer (String.length text) in
  let ctx = Aio.context 32
  in
    Printf.printf "writing '%s'\n" text;
    flush_all ();
    Aio.put_string buffer text;
    Aio.write ctx fd buffer Int64.zero (write_done ctx fd);
    Aio.run ctx;
    (* Create error of pending IO on exit *)
    Aio.read ctx fd buffer Int64.zero read_done
